// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SegLHA.pas' rev: 3.00

#ifndef SegLHAHPP
#define SegLHAHPP
#include <complha.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Seglha
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS ESegLHAError;
class PASCALIMPLEMENTATION ESegLHAError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall ESegLHAError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall ESegLHAError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ESegLHAError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ESegLHAError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ESegLHAError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ESegLHAError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ESegLHAError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ESegLHAError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ESegLHAError(void) { }
	
};

struct TSegIDHeader
{
	char HdrID[4];
	Word SegNumber;
} ;

struct TSegSetHeader
{
	char HdrID[4];
	TCompLHAMethod CompMode;
	System::TDateTime SegDate;
	int SegSize;
} ;

struct TSegScanHeader
{
	char HdrID[4];
	int ScanLen;
} ;

struct TSegArcHeader
{
	char HdrID[4];
	int ArcLen;
} ;

struct TFileInfo
{
	TCompLHAMethod CompressedMode;
	int CompressedSize;
	int FullSize;
	int Datetime;
	short Attributes;
	Byte HeaderLevel;
	Word CRC;
	int Position;
} ;

enum TSegMessageType { smTitle, smWrongSegMounted, smPrompt, smFreeSpaceMsg, smSegAbortMsg, smSegOpenMsg, 
	smScanOpenMsg, smArcOpenMsg, smSegNotFoundMsg, smCorrectCancelMsg, smSegIDHeaderMsg, smSegSetHeaderMsg, 
	smSegScanHeaderMsg, smSegArcHeaderMsg };

typedef void __fastcall (__closure *TSegChangeEvent)(const System::AnsiString SegPath);

typedef void __fastcall (__closure *TSegExpandEvent)(const System::AnsiString CurTargetPath, System::AnsiString 
	&NewTargetPath, Classes::TStrings* &ListOfFiles);

typedef void __fastcall (__closure *TSegPromptEvent)(System::AnsiString &SegDir, const System::AnsiString 
	SegName, Word SegNumber);

class DELPHICLASS TSegLHA;
class PASCALIMPLEMENTATION TSegLHA : public Complha::TCompLHA 
{
	typedef Complha::TCompLHA inherited;
	
private:
	System::AnsiString FSegBaseName;
	System::AnsiString FSegDir;
	System::AnsiString FSegExt;
	Classes::TStrings* FSegMessages;
	int FSegSize;
	System::AnsiString FSegName;
	Word FSegNumber;
	System::AnsiString FSegPath;
	System::AnsiString FTmpFile;
	System::AnsiString FScanFile;
	System::AnsiString FArcFile;
	int FSegBytes;
	int FFreeBytes;
	int FTotalBytes;
	int FBytesProcessed;
	int FSegShowProgress;
	char *FBPtr;
	Classes::TComponent* FMyOwner;
	TSegChangeEvent FOnSegChange;
	TSegExpandEvent FOnSegExpand;
	TSegPromptEvent FOnSegPrompt;
	Complha::TCompLHAFilenameCheckEvent FSaveOnCheckFile;
	Complha::TCompLHAAfterProcessedEvent FSaveOnAfterProcessed;
	Complha::TCompLHAShowProgressEvent FSaveOnShowProgress;
	void __fastcall SetSegBaseName(const System::AnsiString SegBaseName);
	void __fastcall SetSegDir(const System::AnsiString SegDir);
	void __fastcall SetSegExt(const System::AnsiString SegExt);
	void __fastcall SetSegMessages(Classes::TStrings* Messages);
	void __fastcall SetSegSize(int SegSize);
	System::AnsiString __fastcall MakeTmpFile(const System::AnsiString Ext);
	void __fastcall OnCheckFileStub(const System::AnsiString originalFilePath, System::AnsiString &newFilePath
		, int dateTime, Complha::TCompLHAProcessMode mode);
	void __fastcall OnAfterProcessedStub(const System::AnsiString originalFilePath, const System::AnsiString 
		newFilePath, int dateTime, Complha::TCompLHAProcessMode mode);
	void __fastcall OnShowProgressStub(int &PercentageDone);
	void __fastcall DisableEventHandlers(void);
	void __fastcall EnableEventHandlers(void);
	System::AnsiString __fastcall GetSegMessage(TSegMessageType MsgCnt);
	int __fastcall GetFileSize(const System::AnsiString FName);
	void __fastcall SetSegmentPath(void);
	System::AnsiString __fastcall AppendSlash(const System::AnsiString Path);
	void __fastcall RemoveFile(System::AnsiString &Path);
	void __fastcall RemoveSegFiles(void);
	float __fastcall CheckSpace(const System::AnsiString Path);
	bool __fastcall PathPrompt(System::AnsiString &DefDir, const int SegNum, const System::AnsiString SegName
		);
	void __fastcall NewSegmentEvent(void);
	void __fastcall SegmentArchive(void);
	void __fastcall AssembleArchive(bool VerifyOnly);
	void __fastcall ScanSegment(void);
	void __fastcall ReadSegSetHeader(Classes::TFileStream* &fh, TSegSetHeader &SetHdr);
	void __fastcall CreateScanFile(void);
	void __fastcall ReadScanFile(Classes::TFileStream* &fh);
	void __fastcall WriteScanFile(Classes::TFileStream* &fh);
	void __fastcall ReadArchiveFile(Classes::TFileStream* &fh);
	void __fastcall WriteArchiveFile(Classes::TFileStream* &fh);
	Classes::TFileStream* __fastcall CreateSegment(void);
	Classes::TFileStream* __fastcall OpenSegment(void);
	void __fastcall CloseSegment(Classes::TFileStream* &fh);
	void __fastcall WriteToSegment(Classes::TFileStream* &fh, void *Buffer, int Count);
	void __fastcall ReadFromSegment(Classes::TFileStream* &fh, void *Buffer, int Count);
	
public:
	__fastcall virtual TSegLHA(Classes::TComponent* AOwner);
	__fastcall virtual ~TSegLHA(void);
	virtual bool __fastcall Scan(void);
	virtual void __fastcall Compress(void);
	virtual void __fastcall Expand(void);
	virtual void __fastcall Verify(void);
	__property System::AnsiString SegName = {read=FSegName};
	__property Word SegNumber = {read=FSegNumber, nodefault};
	__property System::AnsiString SegPath = {read=FSegPath};
	
__published:
	__property System::AnsiString SegBaseName = {read=FSegBaseName, write=SetSegBaseName};
	__property System::AnsiString SegDir = {read=FSegDir, write=SetSegDir};
	__property System::AnsiString SegExt = {read=FSegExt, write=SetSegExt};
	__property Classes::TStrings* SegMessages = {read=FSegMessages, write=SetSegMessages};
	__property int SegSize = {read=FSegSize, write=SetSegSize, nodefault};
	__property TSegChangeEvent OnSegChange = {read=FOnSegChange, write=FOnSegChange};
	__property TSegExpandEvent OnSegExpand = {read=FOnSegExpand, write=FOnSegExpand};
	__property TSegPromptEvent OnSegPrompt = {read=FOnSegPrompt, write=FOnSegPrompt};
};

//-- var, const, procedure ---------------------------------------------------
#define MINFREE (Word)(2048)
#define BUFSIZE (Word)(8192)
#define SSID "SSID"
#define SSET "SSET"
#define SSCN "SSCN"
#define SARC "SARC"
#define CR "\n\r"
#define NUL (char)(0)
extern PACKAGE System::AnsiString SegMessageDefaults[14];
extern PACKAGE void __fastcall Register(void);

}	/* namespace Seglha */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Seglha;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SegLHA
